
#include <SoftwareSerial.h>
#include <math.h>
#include <SPI.h>
#include <Wire.h>
//#include <avr/pgmspace.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <EEPROM.h>
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
#define SCREEN_ADDRESS 0x3C ///< See datasheet for Address; 0x3D for 128x64, 0x3C for 128x32
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);
#define LOGO_HEIGHT   16
#define LOGO_WIDTH    16
SoftwareSerial BTserial(3, 2); // RX | TX
 float temp,tt,temp_buff;
 int tempPin = A1; // analog input pin
 int sampleTime = 1000; // 1 second dafault
 int curr_value, acc_value;
boolean conn = false;
volatile byte val_t = 0;
boolean at_start = true;
boolean over = false;
boolean heat = false;
volatile char away = ' ';
volatile char da = ' ';
volatile float target_temp = 0;


void setup() 
{
    pinMode(2, OUTPUT);
    pinMode(3, INPUT);
    Serial.begin(38400);
    Serial.println("---------------Master------------------");
    // HC-05 default serial speed for AT mode is 38400
    BTserial.begin(38400);  
    if(!display.begin(SSD1306_SWITCHCAPVCC, SCREEN_ADDRESS)) {};
    display.display(); 
    val_t = EEPROM.read(0);
    delay(500); 
      int print_valt = val_t;
      tt=print_valt*0.4921875;     
      String stojnost=String(tt,1);
           display.clearDisplay();
                robojaxText(stojnost, 12, 28, 3, false);
                robojaxText(String((char)247), 86, 28, 2, false);
                robojaxText("C", 100, 28, 3, false);                
          display.display();
     delay(2500); 
     Serial.print(" Enter the desired temperature : ");
        while ((Serial.available() == 0) && (millis()< 12500))  
           {  target_temp = Serial.parseFloat(); }
                            if ((target_temp > 0)&&(target_temp < 35))
                            {    
                                  Serial.println(target_temp,1);
                                  Serial.println();}  
                                  if ((target_temp > 0)&&(target_temp < 35)) {
                                                           val_t = int(target_temp/0.4921875);
                                                           delay(1000); 
                                                           EEPROM.write(0, val_t); 
                                                           delay(1000);}
                                     
}





void loop() {
        conn=false; 
    // Keep reading from HC-05 and send to Arduino Serial Monitor
        while(BTserial.available()>0)  { 
        char dummy = BTserial.read(); 
        conn=true;}
           temp_meas();            
           delay(sampleTime);  
}



void temp_meas() {
  //gets and prints the raw data from the lm35
  acc_value = 0;
    for (int i=0; i <= 15; i++){
      curr_value = analogRead(tempPin);
      acc_value = acc_value + curr_value;
      }
      curr_value = int(acc_value/16);
  
  //converts raw data into degrees celsius and prints it out
  // 451mV/1024=.48828125
  temp = curr_value * 0.4921875;
  temp_buff=temp;
    if ((tt<=temp)&& at_start) over=true;
    if (over) {
      if (!heat) temp_buff=temp+1.5;      
      at_start=false;
    }
    
  Serial.print("CELSIUS: ");
  Serial.print(temp);
  Serial.println("*C ");
          String to_show = String(temp, 1);
                display.clearDisplay();         
                display.drawRect(4, 12, 120,50, WHITE);
                robojaxText(to_show, 12, 28, 3, false);
                robojaxText(String((char)247), 86, 28, 2, false);
                robojaxText("C", 100, 28, 3, false);                
                robojaxText("Temperature", 32, 3, 1, false);
                if (conn) robojaxText(" Connected", 32, 53, 1, false);
          display.display();
if (tt>temp_buff)
         {
          BTserial.print("y");
         heat=true;
         }   
if (tt<=temp_buff)
         {
          BTserial.print("n");
         heat=false;
         }  
         if (!conn) BTserial.flush();
}
  
   

void robojaxText(String text, int x, int y,int size, boolean d) {
  display.setTextSize(size);
  display.setTextColor(WHITE);
  display.setCursor(x,y);
  display.println(text);
  if(d){
    display.display();
  }  
}
